; This is just a very raw example using speak and speak to a file.
Global RecFlag.b
Global TxtLen.l

Procedure PositionEvent(Charac.l) ; This is the OnPosition event function.
  StatusBarText(0,1," Position = "+Str(Charac*100/TxtLen)+"%")
EndProcedure

Procedure StartedEvent() ; This is the OnAudioStart event function.
  StatusBarText(0,2,"")
  If RecFlag=0
    StatusBarText(0,0," Speaking")
  Else
    StatusBarText(0,0," Recording")
  EndIf
EndProcedure

Procedure EndedEvent() ; And this is the OnAudioStop event function.
  StatusBarText(0,1," Position = 100%")
  Delay(1000)
  StatusBarText(0,0," Finished")
  StatusBarText(0,1,"")
EndProcedure

If OpenWindow(0, 357, 98, 375, 65,  #PB_Window_TitleBar | #PB_Window_ScreenCentered | #PB_Window_SystemMenu, "PureTTS Clipboard Player")
  
  If CreateStatusBar(0, WindowID())
    AddStatusBarField(100)
    AddStatusBarField(100)
    AddStatusBarField(300)
    StatusBarText(0,2," Initializing SAPI...")
    
    If TTSInit(@StartedEvent(),@EndedEvent(),@PositionEvent()) ; Here we initialize the SAPI enviroment.
      
      If CreateGadgetList(WindowID())
        ButtonGadget(0, 5, 5, 60, 30, "Play",#PB_Button_Default)
        ButtonGadget(1, 70, 5, 60, 30, "Record")
        ButtonGadget(2, 135, 5, 60, 30, "Stop")
        ButtonGadget(3, 200, 5, 60, 30, "Pause", #PB_Button_Toggle)
        ListViewGadget(4,270,5,100,30)
        
        StatusBarText(0,2," Enumerating voices...")
        
        For i=0 To TTSEngCount() ; Retrieve the voice names and store them.
          AddGadgetItem (4,-1,TTSEngName(i))
        Next
        SetGadgetState (4,0)
        StatusBarText(0,2," Just copy some text and click Play")
        
        Repeat
          EventID = WaitWindowEvent() 
          Select EventID
            Case #PB_Event_Gadget
              Select EventGadgetID()
                Case 0
                  txt$=GetClipboardText()
                  TxtLen=Len(txt$)
                  If TxtLen>0
                    RecFlag=0 ; We are not recording.
                    TTSSpeak(txt$) ; Speak the clipboard text.
                  EndIf
                Case 1
                  txt$=GetClipboardText()
                  TxtLen=Len(txt$)
                  If TxtLen>0
                    WavFile.s = SaveFileRequester("Save speech as wav",".wav", "Audio files|*.wav|All files|*.*", 0) 
                    If WavFile <> ""
                      RecFlag=1 ; We are recording.
                      TTSSpeak(txt$,WavFile) ; Send the speech to the designated file.
                    EndIf
                  EndIf
                Case 2
                  TTSStop() ; Just stop speaking or recording.
                Case 3
                  If GetGadgetState(3)=1
                    TTSPause() ; Self explained.
                  Else
                    TTSResume() ; This too.
                  EndIf
                Case 4
                  i=GetGadgetState(4)
                  TTSSelect(i) ; Select a voice by its index.
              EndSelect 
          EndSelect
        Until EventID = #PB_Event_CloseWindow
      EndIf
      TTSEnd() ; Free SAPI resources.
    EndIf
  EndIf
EndIf
End