; This is a very raw example using PureTTS to demonstrate how to speak what you are typing.
; Maybe useful for people with impaired sight too.
Procedure speakit()
  SendMessage_(GadgetID(2),#EM_EXGETSEL,0,@pos.CHARRANGE) ; Retrieve the cursor position.
  start=pos\cpMax-50
  If start<0
    start=0
  EndIf
  wordrange.TEXTRANGE
  wordrange\chrg\cpMin=start
  wordrange\chrg\cpMax=pos\cpMax
  pieceoftext.s=Space(51)
  wordrange\lpstrText=@pieceoftext
  SendMessage_(GadgetID(2),#EM_GETTEXTRANGE,0,@wordrange) ; Now, retrieve a piece of text 50 characters long (or less).
  While CountString(pieceoftext,Chr(13)) 
    pieceoftext=ReplaceString(pieceoftext,Chr(13)," "); Change each CR to SPACE.
  Wend
  hmspaces = CountString(pieceoftext," ")+1 ; Count how many spaces are in the piece of text.
  lastword.s = StringField(pieceoftext,hmspaces," ") ; Get the last word.
  TTSSpeak(lastword.s) ; And speak it.
EndProcedure


If OpenWindow(0, 335, 159, 480, 340,  #PB_Window_TitleBar | #PB_Window_ScreenCentered | #PB_Window_SystemMenu , "Type and Speak")
  If CreateGadgetList(WindowID())
    TextGadget(0, 80, 20, 130, 20, "Please choose a voice", #PB_Text_Right)
    ListViewGadget(1, 230, 10, 150, 30)
    EditorGadget(2, 10, 50, 460, 280)
    AddKeyboardShortcut(0, #PB_Shortcut_Space, 0)
    AddKeyboardShortcut(0, #PB_Shortcut_Return, 1)
    
    GID=GadgetID(2) 
    dc=GetWindowDC_(GID) 
    SendMessage_(GID, #EM_SETTARGETDEVICE ,dc ,-1) 
    ReleaseDC_(GID,dc)
    SendMessage_(GadgetID(2), #EM_LIMITTEXT, -1, 0)
    
    If TTSInit(0,0,0) ; Initialize the speech enviroment. 
      For i=0 To TTSEngCount() ; Retrieve the voice names and store them.
        AddGadgetItem (1,-1,TTSEngName(i))
      Next
      SetGadgetState (1,0)
    Else
      MessageRequester("Text-To-Speech support not found!", "Please check your speech configuration at the Control Panel.", #MB_OK|#MB_ICONWARNING) 
    EndIf
    
    SetGadgetText(2,"Just type some text"+Chr(13))
    
    Repeat
      ev=WaitWindowEvent()
      If ev=#PB_EventGadget And EventGadgetID()=1
        TTSStop() ; Stop any speech.
        i=GetGadgetState(1)
        nam$=GetGadgetText(1)
        TTSSelect(i) ; Select a voice by its index
        TTSSpeak(nam$) ; Speak the voice name.
      ElseIf ev=#PB_EventMenu
        men=EventMenuID()
        Select men
          Case 0
            replacement.s=" "
            speakit() 
            SendMessage_(GadgetID(2),#EM_REPLACESEL,0,@replacement) ; Insert a space in the EditorGadget.
          Case 1
            replacement.s=Chr(13)
            speakit()
            SendMessage_(GadgetID(2),#EM_REPLACESEL,0,@replacement) ; Insert a CR in the EditorGadget
        EndSelect
      EndIf
    Until ev=#PB_Event_CloseWindow
  EndIf
  TTSEnd() ; End speech support.
EndIf
End