; This is just a raw example using events.
Global noevents.b

Procedure started()
  StatusBarText(0,0,"Speaking",#PB_StatusBar_Center)
EndProcedure


Procedure ended()
  StatusBarText(0,0,"Not speaking",#PB_StatusBar_Center)
EndProcedure

Procedure position(Charac.l)
  If noevents=0
    StatusBarText(0,1,"Position= "+Str(Charac),#PB_StatusBar_Center)
    txtend=SendMessage_(GadgetID(0),#EM_FINDWORDBREAK,#WB_RIGHTBREAK,Charac+1) 
    txtstart=SendMessage_(GadgetID(0),#EM_FINDWORDBREAK,#WB_MOVEWORDLEFT,Charac+1)
    range.CHARRANGE
    range\cpMin=txtend
    range\cpMax=txtstart
    SendMessage_(GadgetID(0),#EM_EXSETSEL,0,range)
  EndIf
EndProcedure

If OpenWindow(0, 265, 124, 311, 374, "PureTTS Reader",  #PB_Window_TitleBar | #PB_Window_ScreenCentered | #PB_Window_SystemMenu )
  
  If CreateStatusBar(0,WindowID(0))
    AddStatusBarField(156)
    AddStatusBarField(156)
    
    
    If CreateGadgetList(WindowID(0))
      EditorGadget(0, 5, 5, 300, 145)
      ButtonGadget(1, 10, 160, 50, 25, "Paste")
      ButtonGadget(2, 70, 160, 50, 25, "Speak")
      ButtonGadget(3, 130, 160, 50, 25, "Stop")
      ButtonGadget(4, 190, 160, 50, 25, "Pause",#PB_Button_Toggle)
      ButtonGadget(5, 250, 160, 50, 25, "To File")
      TrackBarGadget(6, 55, 200, 250, 20, 0, 20, #PB_TrackBar_Ticks)
      TrackBarGadget(7, 55, 225, 250, 20, 0, 20, #PB_TrackBar_Ticks)
      TrackBarGadget(8, 55, 250, 250, 20, 0, 100, #PB_TrackBar_Ticks)
      ListViewGadget(9, 100, 290, 190, 60)
      TextGadget(10, 5, 200, 40, 20, "Speed", #PB_Text_Right)
      TextGadget(11, 5, 225, 40, 20, "Pitch", #PB_Text_Right)
      TextGadget(12, 5, 250, 40, 20, "Volume", #PB_Text_Right)
      TextGadget(13, 5, 290, 90, 25, "Choose a voice", #PB_Text_Right) 
      GID=GadgetID(0) 
      dc=GetWindowDC_(GID) 
      SendMessage_(GID, #EM_SETTARGETDEVICE ,dc ,-1) 
      ReleaseDC_(GID,dc)
      SendMessage_(GadgetID(0), #EM_LIMITTEXT, -1, 0)
      StatusBarText(0,0,"Initializing SAPI...",#PB_StatusBar_Center)
      
      If TTSInit(@started(),@ended(),@position())
        voices=TTSEngCount()
        StatusBarText(0,0,"Enumerating voices...",#PB_StatusBar_Center)
        For i=0 To voices
          AddGadgetItem (9,-1,TTSEngName(i))
        Next
        StatusBarText(0,0,"Ready",#PB_StatusBar_Center)
        SetGadgetText(0,"Just copy some text and click the 'Paste' button.")
        SetGadgetState(9,0)
      Else
        MessageRequester("Text-To-Speech support not found!", "Please check your speech configuration at the Control Panel.", #MB_OK|#MB_ICONWARNING)
      EndIf
      
      Repeat
        ev=WaitWindowEvent()
        If ev=#PB_Event_Gadget
          Select EventGadget()
            Case 1
              SetGadgetText(0,"")
              SendMessage_(GadgetID(0),#WM_PASTE,0,0)
            Case 2
              noevents=0
              t$=GetGadgetText(0)
              t$=ReplaceString(t$,Chr(13)+Chr(10)," ")
              TTSSpeak(t$)
            Case 3
              TTSStop()
            Case 4
              If GetGadgetState(4)=1
                TTSPause()
                SetGadgetText(4,"Resume")
              Else
                TTSResume()
                SetGadgetText(4,"Pause")
              EndIf
            Case 5
              TTSStop()
              tofile.s = SaveFileRequester("Save speech as wav",".wav", "Audio files|*.wav|All files|*.*", 0) 
              If tofile <> ""
                noevents=0
                t$=GetGadgetText(0)
                t$=ReplaceString(t$,Chr(13)+Chr(10)," ")
                TTSSpeak(t$,tofile)
              EndIf
            Case 6
              asp=GetGadgetState(6)
              TTSSetSpeed(asp-10)
            Case 7
              api=GetGadgetState(7)
              TTSSetPitch(api-10)
            Case 8
              avo=GetGadgetState(8)
              TTSSetVolume(avo)
            Case 9
              TTSStop()
              noevents=1
              i=GetGadgetState(9)
              nam$=GetGadgetText(9)
              TTSSelect(i)
              TTSSpeak(nam$)
              SetGadgetState(6,TTSGetSpeed()+10)
              SetGadgetState(7,TTSGetPitch()+10)
              SetGadgetState(8,TTSGetVolume())
          EndSelect
        EndIf
      Until ev=#PB_Event_CloseWindow
      TTSEnd()
    EndIf
  EndIf
EndIf
End