;This is another example using PureTTS, maybe useful for people with impaired sight.
;First we create a window.
If OpenWindow(0, 265, 144, 250, 200,  #PB_Window_SystemMenu | #PB_Window_TitleBar | #PB_Window_ScreenCentered , "Speaking Gadgets")
  
  If CreateGadgetList(WindowID(0)) ;Then we create some gadgets.
    ButtonGadget(0, 30, 10, 80, 30, "Button Gadget")
    StringGadget(1, 145, 10, 80, 30, "String Gadget")
    CheckBoxGadget(2, 15, 75, 110, 30, "CheckBox Gadget")
    TextGadget(3, 145, 55, 80, 30, "Text Gadget", #PB_Text_Border)
    HyperLinkGadget(4, 25, 140, 100, 25, "Hyperlink Gadget", RGB(0, 0, 0))
    EditorGadget(5, 145, 105, 80, 80)
    SetGadgetText(5, "Editor Gadget")
    
    If TTSInit(0,0,0) ;Let's initialize the SAPI support.
      TTSSelect(0) ;Now we select a voice by its index. I choose index 0, for example. 
    Else
      MessageRequester("Text-To-Speech support not found!", "Please check your speech configuration at the Control Panel.", #MB_OK|#MB_ICONWARNING) 
    EndIf
    
      Repeat 
        
        GetCursorPos_ (@p.POINT) ;Get the cursor position in p.POINT.
        ScreenToClient_ (WindowID(0), @p) ;Convert the coordinates to window ones.
        gad=ChildWindowFromPoint_ (WindowID(0), p\x, p\y) ;Get the gadget under that point.
        If gad<>gadmem And gad<>0 ; If the gadget under the point has changed and is valid.
          gadmem=gad ;Remember which gadget it was.
          If gad<>WindowID(0) ;If the point is not just the window background.
            txt.s=Space(100) ;Make some room for the text.
            GetWindowText_(gad,@txt,100) ;Retrieve the gadget text.
            TTSSpeak(txt) ;And speak it.
          EndIf
        EndIf
        
      Until WaitWindowEvent () = #PB_Event_CloseWindow 
      TTSEnd() ; Terminate the SAPI support. 
  EndIf
EndIf  
End